"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = babel_plugin_inferred_react_component;

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function babel_plugin_inferred_react_component(options) {
    return {
        visitor: {
            Program: {
                enter: function enter(path, state) {
                    state.ref_component = path.scope.generateUidIdentifier("_component");
                },
                exit: function exit(path, state) {
                    var body = path.scope.block.body;
                    var _options$reactRequire = options.reactRequires,
                        reactRequires = _options$reactRequire === undefined ? "react" : _options$reactRequire;


                    var reactRequired = t.objectProperty(t.identifier("Component"), state.ref_component);
                    var reactImport = t.importSpecifier(state.ref_component, t.identifier("Component"));

                    var existingImport = body.find(function (statement) {
                        return statement.source && statement.source.value == reactRequires;
                    });

                    if (!state.extention_used) return;

                    if (existingImport) existingImport.specifiers.push(reactImport);else body.unshift(requirement(reactRequires, [reactRequired])
                    // t.importDeclaration(
                    //     [reactRequired], t.stringLiteral(reactRequires)
                    // )
                    );
                }
            },
            Class: {
                enter: function enter(path, state) {
                    if (isClassComponent(path, this.opts)) {
                        state.extention_used = true;
                        polyfillComponent(path, state.ref_component);
                    }
                }
            }
        }
    };
}

var t = require("babel-types");

function repairConstructor(constructor, params) {

    var body = constructor.node.body.body;
    var superAt = void 0,
        thisFirstUsedAt = void 0,
        thisFirstUsedTimes = 1;

    for (var item, i = 0; item = body[i]; i++) {
        if (item.type != "ExpressionStatement") continue;
        item = item.expression;
        if (item.type != "CallExpression") continue;
        item = item.callee;
        if (item.type == "Super" || item.type == "Identifier" && item.name == "super") {
            superAt = i;
            break;
        } else continue;
    }

    for (var _item, _i = 0, stopAt = superAt || body.length; _i < stopAt; _i++) {
        var _item2 = body[_i];
        if (_item2.type != "ExpressionStatement") continue;
        _item2 = _item2.expression;
        if (_item2.type != "AssignmentExpression") continue;
        _item2 = _item2.left;
        if (_item2.type != "MemberExpression") continue;
        _item2 = _item2.object;
        if (_item2.type != "ThisExpression") continue;
        if (thisFirstUsedAt === undefined) thisFirstUsedAt = _i;else thisFirstUsedTimes++;
    }

    var format = Array.from(body);

    if (thisFirstUsedAt < superAt) {
        var probablyClassParams = format.splice(thisFirstUsedAt, thisFirstUsedTimes);

        format.splice.apply(format, [superAt + 1, 0].concat(_toConsumableArray(probablyClassParams)));
    } else if (superAt === undefined && thisFirstUsedAt !== undefined) {
        var _props = params[0];
        var _struct = void 0;

        if (!_props || _props.type == "ObjectPattern") {
            _struct = _props;
            _props = params[0] = constructor.scope.generateUidIdentifier("props");
        }

        if (_struct) constructor.scope.push({
            type: "const",
            id: _struct,
            init: _props
        });

        format.splice(thisFirstUsedAt, 0, t.expressionStatement(t.callExpression(t.super(), [_props])));
    } else return;

    constructor.get("body").replaceWith(t.blockStatement(format));
}

function requirement(from, destructure) {
    return t.variableDeclaration("const", [t.variableDeclarator(t.objectPattern(destructure), t.callExpression(t.identifier("require"), [t.stringLiteral(from)]))]);
}

function isClassComponent(path, opts) {
    var alreadyExtended = path.get("superClass");

    if (alreadyExtended.isNullLiteral()) {
        path.node.superClass = null;
        return false;
    }
    if (alreadyExtended.node) return false;

    return path.node.body.body.find(function (x) {
        var name = x.key.name;

        return x.type == "ClassMethod" && opts.activeOnMethodRender != false && name == "render" || opts.activeOnMethodDo != false && name == "do" || path.node.id && name == path.node.id.name;
    });
}

function polyfillComponent(path, _component) {
    path.node.superClass = _component;

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = path.get("body.body")[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var statement = _step.value;
            var _statement$node = statement.node,
                type = _statement$node.type,
                key = _statement$node.key,
                params = _statement$node.params;

            if (type == "ClassMethod" && key.name == "constructor") repairConstructor(statement, params);
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}